﻿#! /usr/bin/perl
use Net::FTP;
use IO::Socket::INET;

# flush after every write
$| = 1;



my ($Sekunden, $Minuten, $Stunden, $Monatstag, $Monat,
    $Jahr, $Wochentag, $Jahrestag, $Sommerzeit) = localtime(time);
$sek = $Sekunden;
my $CTIME_String = localtime(time);

$Monat+=1;
$Jahrestag+=1;
$Monat = $Monat < 10 ? $Monat = "0".$Monat : $Monat;
$Monatstag = $Monatstag < 10 ? $Monatstag = "0".$Monatstag : $Monatstag;
$Stunden = $Stunden < 10 ? $Stunden = "0".$Stunden : $Stunden;
$Minuten = $Minuten < 10 ? $Minuten = "0".$Minuten : $Minuten;
$Sekunden = $Sekunden < 10 ? $Sekunden = "0".$Sekunden : $Sekunden;
$Jahr+=1900;
my @Wochentage = ("Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag");
my @Monatsnamen = ("","Januar","Februar","M&auml;rz","April","Mai","Juni",
           "Juli","August","September","Oktober","November","Dezember");


$PumpeHK1="aus";
print "PumpeHK1 start Status:"."$PumpeHK1"."\n";
$PumpeBoiler="aus";
print "PumpeBoiler start Status:"."$PumpeBoiler"."\n";
$Stoerung="false";
print "Störung Status:"."$Stoerung"."\n";
$FB_HK1="none";
print "\n";
print "\n";
print "Programm läuft, 10 Sekunden warten";
print "\n";
sleep(10);

my @output = qx(killall nc);
print "@output\n";

#Heizung.log kopieren, kann zur Analyse aktiviert werden! (in dieser Zeile Raute nicht entfernen!!)
#my @output = qx(cp /home/heizung/Heizung/Heizung.log /home/heizung/Heizung/LOG/Heizung"."$Jahr"."$Monat"."$Monatstag"."$Stunden"."$Minuten"."$Sekunden".".log);
#print "@output\n";


if (-z "/home/heizung/Heizung/Heizung.log")
{ print "Heizung.log enthält KEINE Daten, Perl wird beendet!"; exit}
else {print "Heizung.log enthält Daten, Perl beginnt die Daten zu verarbeiten";print "\n";}
print "\n";
open ($fd, "< /home/heizung/Heizung/Heizung.log") or die "Datei Heizung.log ist nicht vorhanden, Perl wird beendet!";

while(getc($fd) ne "\n"){} #erste Zeile verwerfen

print $fd

$c= "";
$output = "";
while($c ne "\n") {
  $c = getc($fd);
  $output = $output.$c;
}              #die zweite Zeile ist komplett


print "\n";
print "Daten von: $Stunden.$Minuten:$Sekunden Uhr\n";

my @new=split(/ /,$output);
 if ($new[1]=="1") { print "Status "."$new[1]".": Heizung aus\n";}
 if ($new[1]=="2") { print "Status "."$new[1]".": Heizung kurz aus\n";}
 if ($new[1]=="4") { print "Status "."$new[1]".": Zundueberwachung";}
 if ($new[1]=="5") { print "Status "."$new[1]".": Zuendung\n";}
 if ($new[1]=="6") { print "Status "."$new[1]".": Uebergang LB\n";}
 if ($new[1]=="7") { print "Status "."$new[1]".": Leistungsbrand\n";}
 if ($new[1]=="10") { print "Status "."$new[1]".": Entaschung\n";}
 if ($new[1]=="12") { print "Status "."$new[1]".": Putzen\n";}
 if ($new[1]=="14") { print "Status "."$new[1]".": Pellet nachfuellen\n";}
 if ($new[1]=="15") { print "Status "."$new[1]".": Kessel Handbetrieb\n";}
 print "Kessel: "."$new[4]"."°\n";
 print "Aussentemp: "."$new[7]"."°\n";
 print "Puffer: "."$new[9]"."°\n";
 print "Heizkreis1 ist: "."$new[22]"."°\n";
 print "Heizkreis1 soll: "."$new[24]"."°\n";
 print "Boiler: "."$new[28]"."°\n";
 print "Raumtemperatur: "."$new[139]"."°\n";
 print "Foerderrat: "."$new[57]"."%\n";

# Daten in rrd Datenbank abspeichern
my $update="rrdtool update heizung.rrd "."N:"."$new[4]".":"."$new[7]".":"."$new[22]".":"."$new[24]".":"."$new[28]".":"."$new[139]".":"."$new[57]".":"."$new[9]\n";
qx ($update);
print "$update";

print "\n";
my $Pumpean = "4000";
my $PumpeKessel = "2000";
my $Stoerungvorhanden = "6";
print "\n";
print "Pumpenwert:"."$Pumpean";
print "\n";
print "Störungswert:"."$Stoerungvorhanden ";
print "\n";
print "Wert im Feld 148 PumpeKessel:"." $new[148]";
print "\n";
print "Wert im Feld 149 PumpeHK1:"." $new[149]";
print "\n";
print "\n";
if ($new[148] == $PumpeKessel) {print "Pumpe Boiler an\n";$PumpeBoiler="an";} else {print "Pumpe Boiler aus\n";};
if ($new[149] == $Pumpean) {print "Pumpe HK1 an\n";$PumpeHK1="an";} else {print "Pumpe HK1 aus\n";};
if ($new[86] == $Stoerungvorhanden) {print "Störung vorhanden\n";$Stoerung="true";} else {print "Keine Störung\n";};
print "\n";

#if ($Stoerung eq "true") {qx (python Mail.py Stoerung kritisch);}

# Grafik generieren
my $Befehl1="rrdtool graph "."$Jahr"."$Monat"."$Monatstag".".png --start end-24h --title \""."$Monatstag".". "."$Monatsnamen[$Monat]"." "."$Jahr"."\" ";
my $Befehl2=" --width 800 --height 200 --right-axis 1:0 HRULE:50#B0B0B0 HRULE:60#B0B0B0 DEF:kessel=heizung.rrd:kessel:AVERAGE DEF:boiler=heizung.rrd:boiler:AVERAGE DEF:puffer=heizung.rrd:puffer:AVERAGE DEF:aussen=heizung.rrd:aussen:AVERAGE VDEF:max=aussen,MAXIMUM VDEF:min=aussen,MINIMUM DEF:hk1ist=heizung.rrd:hk1ist:AVERAGE DEF:hk1soll=heizung.rrd:hk1soll:AVERAGE DEF:foerder=heizung.rrd:foerder:AVERAGE DEF:raum=heizung.rrd:raum:AVERAGE ";
my $Befehl3="AREA:foerder#FFDEAD:\"Foerderrate\" LINE1:hk1soll#800000:\"HK 1 soll\" LINE2:hk1ist#00FF00:\"HK 1 ist\" LINE2:kessel#000000:\"Kessel\" LINE2:boiler#FF0000:\"Boiler\" LINE2:puffer#FF9900:\"Puffer\" LINE2:raum#FFFF00:\"Raumtemp EG\"  LINE2:aussen#00FFFF:\"Aussentemp\" GPRINT:min:\"Min %2.1lf°\" GPRINT:max:\"Max %2.1lf°\"  \n";
my $Befehl="$Befehl1"."$Befehl2"."$Befehl3";
qx ($Befehl);

print "\nBefehl ausgefuehrt";

my $Tagesdatei="$Jahr"."$Monat"."$Monatstag".".png";
print "\n$Tagesdatei";

#Pelletverbrauch berechnen
#Abhängig vom Gerätetyp der Heizung muss der Wert *= 0.00145 angepasst werden
#
# Bepiel:
# 22 KWFördermenge 8,7 geteilt durch 60 (Minuten) geteilt durch 100 = 0.00145
# Es werden also 0,00145 KG Pellet pro Minute verbraucth bei 1% Förderleistung
#
# KW der Heizung      Fördermenge in kg/h
# 9                   6,4
# 12                  6,4
# 14                  6,4
# 15                  6,4
# 22                  8,7
# 25                  9,25
# 31                  9,25
# 35                  9,25
# 40                 10,40
# 49                 14,40
# 60                 14,40

#$pelletverbrauch von Datei /home/heizung/test/pelletverbrauch.txt lesen
my $pelletverbrauch = "/home/heizung/Heizung/Pelletverbrauch/pelletverbrauch.txt";
open (my $fh, "<$pelletverbrauch") or die "Fehler beim lesen der Datei pelletverbrauch.txt";

my $pelletverbrauchalt = <$fh>;
print "\n";
print "Alter Pelletwert: $pelletverbrauchalt\n";
print "\n";

$pelletverbrauchmin = $new[57];
print "Förderschnecke: $pelletverbrauchmin\n";
$pelletverbrauchmin *= 0.00145;
$pelletverbrauchalt +=  $pelletverbrauchmin;

print "Neuer Pelletwert: $pelletverbrauchalt\n";
print "\n";
open (pelletverbrauchberechnen, ">/home/heizung/Heizung/Pelletverbrauch/pelletverbrauch.txt") or die "Fehler beim schreiben der Datei pelletverbrauch.txt";
print pelletverbrauchberechnen "$pelletverbrauchalt";
close (pelletverbrauchberechnen);

#$pelletverbrauch von Datei /home/heizung/test/pelletverbrauchtag.txt lesen
my $pelletverbrauchtag = "/home/heizung/Heizung/Pelletverbrauch/pelletverbrauchtag.txt";
open (my $fhh, "<$pelletverbrauchtag") or die "Fehler beim lesen der Datei pelletverbrauchtag.txt";

my $pelletverbrauchtagalt = <$fhh>;
print "\n";
print "Alter Pelletwert (Tag): $pelletverbrauchtagalt\n";
print "\n";

$pelletverbrauchtagmin = $new[57];
print "Förderschnecke: $pelletverbrauchtagmin\n";
$pelletverbrauchtagmin *= 0.00145;
$pelletverbrauchtagalt +=  $pelletverbrauchtagmin;

print "Neuer Pelletwert (Tag): $pelletverbrauchtagalt\n";
print "\n";
open (pelletverbrauchtagberechnen, ">/home/heizung/Heizung/Pelletverbrauch/pelletverbrauchtag.txt") or die "Fehler beim scheiben der Datei pelletverbrauchtag.txt";
print pelletverbrauchtagberechnen "$pelletverbrauchtagalt";
close (pelletverbrauchtagberechnen);


#$pelletverbrauch von Datei /home/heizung/test/pelletverbrauchmonat.txt lesen
my $pelletverbrauchmonat = "/home/heizung/Heizung/Pelletverbrauch/pelletverbrauchmonat.txt";
open (my $fhhh, "<$pelletverbrauchmonat") or die "Fehler beim lesen der Datei pelletverbrauchmonat.txt";

my $pelletverbrauchmonatalt = <$fhhh>;
print "\n";
print "Alter Pelletwert (Monat): $pelletverbrauchmonatalt\n";
print "\n";

$pelletverbrauchmonatmin = $new[57];
print "Förderschnecke: $pelletverbrauchmonatmin\n";
$pelletverbrauchmonatmin *= 0.00145;
$pelletverbrauchmonatalt +=  $pelletverbrauchmonatmin;

print "Neuer Pelletwert (Monat): $pelletverbrauchmonatalt\n";
print "\n";
open (pelletverbrauchmonatberechnen, ">/home/heizung/Heizung/Pelletverbrauch/pelletverbrauchmonat.txt") or die "Fehler beim schreiben der Datei pelletverbrauchmonat.txt";

print pelletverbrauchmonatberechnen "$pelletverbrauchmonatalt";
close (pelletverbrauchmonatberechnen);


print "\n";
print "\n Pelletverbrauch in den Ordner Archiv kopieren";
my $Befehl8="cp /home/heizung/Heizung/Pelletverbrauch/pelletverbrauchtag.txt /home/heizung/Heizung/Pelletverbrauch/Archiv/pelletverbrauchtag$Jahr"."$Monat"."$Monatstag.txt";
qx ($Befehl8);
print "\n";


#  Daten im LAN verteilen 
#$socket = new IO::Socket::INET (
#PeerAddr   => '192.168.2.82:50000',         #Ip@ von zweitem Paspberry
#Proto        => 'udp'
#) or die "ERROR in Socket Creation : $!\n";
#send operation
#data = "data from client";
#$socket->send($new[1]." ".$new[3]." ".$new[5]." ".$new[7]." ".$new[9]." ".$new[11]." ".$new[13]);

#sleep(2);
#$socket->close();


open (TXT, ">status.html");
print TXT "<Content-Type: Text/html; charset=iso-8859-1>";
print TXT "<HTML>\n";
  print TXT "<HEAD><TITLE> Heizung Kesselstatus </TITLE>\n";
  print TXT "<meta http-equiv=\"refresh\" content=\"300\" /></HEAD>";

  if ($Stoerung eq "false") { print TXT "<BODY bgcolor=\"\#FFFFFF\"\>\n"};
  if ($Stoerung eq "true") { print TXT "<BODY bgcolor=\"\#FF0000\"\>\n"};
     print TXT "<H2>Kesselstatus $Stunden:$Minuten Uhr $Monatstag.$Monat.$Jahr</H2>\n";
      print TXT "<table border=\"0\"><span style=\"font-size:large\">";
      if ($new[1]=="1") { print TXT "<tr><td bgcolor=\"\#FFCCFF\">Status: <b>Heizung aus</b></td><td></td></tr>";}



      if ($new[1]=="2") { print TXT "<tr><td bgcolor=\"\#FFCCFF\">Status: <b>Heizung kurz aus</b></td><td></td></tr>";}

      if ($new[1]=="4") { print TXT "<tr><td>Status "."$new[1]".": Zuendueberwachung</td><td></td></tr>";}
      if ($new[1]=="5") { print TXT "<tr><td>Status "."$new[1]".": Zuendung</td><td></td></tr>";}
      if ($new[1]=="6") { print TXT "<tr><td bgcolor=\"\#FF0000\">Status: <b> Uebergang Leistungsbrand</b></td><td></td></tr>";}
      if ($new[1]=="7") { print TXT "<tr><td bgcolor=\"\#FF0000\">Status: <b> Leistungsbrand</b></td><td></td></tr>";}

      if ($new[1]=="9") { print TXT "<tr><td>Status "."$new[1]".": Kessel Entaschung</td><td></td></tr>";}
      if ($new[1]=="10") { print TXT "<tr><td>Status "."$new[1]".": Kessel Entaschung Rost</td><td></td></tr>";}
      if ($new[1]=="12") { print TXT "<tr><td>Status "."$new[1]".": Putzen</td><td></td></tr>";}

      if ($new[1]=="14") { print TXT "<tr><td>Status "."$new[1]".": Pellets nachfuellen</td><td></td></tr>";}
      if ($new[1]=="15") { print TXT "<tr><td>Status "."$new[1]".": Heizung Handbetrieb</td><td></td></tr>";}

#Meldungen noch unbekannt!!
      if ($new[1]=="3") { print TXT "<tr><td>Status "."$new[1]".": Meldung3</td><td></td></tr>";}
      if ($new[1]=="8") { print TXT "<tr><td>Status "."$new[1]".": Meldung8</td><td></td></tr>";}

      if ($new[1]=="11") { print TXT "<tr><td>Status "."$new[1]".": Meldung11</td><td></td></tr>";}
      if ($new[1]=="13") { print TXT "<tr><td>Status "."$new[1]".": Meldung13</td><td></td></tr>";}
      if ($new[1]=="16") { print TXT "<tr><td>Status "."$new[1]".": Meldung16</td><td></td></tr>";}
      if ($new[1]=="17") { print TXT "<tr><td>Status "."$new[1]".": Meldung17</td><td></td></tr>";}
      if ($new[1]=="18") { print TXT "<tr><td>Status "."$new[1]".": Meldung18</td><td></td></tr>";}
      if ($new[1]=="19") { print TXT "<tr><td>Status "."$new[1]".": Meldung19</td><td></td></tr>";}
      if ($new[1]=="20") { print TXT "<tr><td>Status "."$new[1]".": Meldung20</td><td></td></tr>";}
#... eventuell gibt es noch andere werte 20-99??

      print TXT "<tr><td>Kesseltemperatur: "."$new[4]"."&#176;</td><td>Aussentemperatur: "."$new[7]"."&#176;</td><td>&nbsp;&nbsp;&nbsp;&nbsp;Heizkreis 1 Pumpe: "."$PumpeHK1"."</td></tr>";
      print TXT "<tr><td>HK1 ist: "."$new[22]"."&#176;</td><td>HK1 soll: "."$new[24]"."&#176;</td><td>&nbsp;&nbsp;&nbsp;&nbsp;Boiler Pumpe: "."$PumpeBoiler"."</td></tr>";
      print TXT "<tr><td>Boilertemperatur: "."$new[28]"."&#176;</td><td>Raumtemperatur: "."$new[139]"."&#176;</td><td>&nbsp;&nbsp;&nbsp;&nbsp;</td></tr>";
      print TXT "<tr><td>Puffertemperatur: "."$new[9]"."&#176 </td></tr>";
      print TXT "<tr><td><br></td></tr>";
      print TXT "<tr><td><b>Pelletverbrauch (+-25 Prozent): </b> </td></tr>";
      print TXT "<tr><td>Pelletverbrauch seit Befuellung des Pelletlagers: "."$pelletverbrauchalt"." kg </td></tr>";
# Beim befüllen muss die Datei manuell auf 0 gestellt werden!!
      print TXT "<tr><td>Pelletverbrauch dieser Monat: <b>"."$pelletverbrauchmonatalt"." kg </b> </td></tr>";
      print TXT "<tr><td>Pelletverbrauch dieser Tag: <b>"."$pelletverbrauchtagalt"." kg </b> </td></tr>";
      print TXT "<tr><td>Foerderleistung: "."$new[57]"."% </td><td></td>";
      print TXT "<tr><td><A HREF=\"1Historie\">Historie</A></td></td><td>";
      if ($Stoerung eq "true") { print TXT "<td bgcolor=\"\#FF0000\"><b>&nbsp;&nbsp;Stoerung !!!</b></td>";}      print TXT "</tr>";
      print TXT "</span></table>";
      print TXT "<br><br>";
      my $Tagesdatei="$Jahr"."$Monat"."$Monatstag".".png";
      print TXT "<img src=\""."$Tagesdatei". "\" alt=\"noch kein Bild vorhanden ;-(\"><br><br>";
      print TXT "<br>";
#      my $wetter="w"."$Jahr"."$Monat"."$Monatstag".".png";
#      print TXT "<img src=\""."$wetter". "\" alt=\"noch kein Bild vorhanden ;-(\"><br><br>";
     print TXT "<HR>\n";
     print TXT "&copy;&nbsp;&nbsp;<a href=\"mailto:Email\@gmx.de\">Vorname Nachname<a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF=\"impressum.html\">Impressum</A>";
     print TXT "<HR>\n";
print TXT "</BODY></HTML>\n";
close TXT;


print "\n";
print "\nkopiere Historie auf den Ordner Historie";
my $Befehl6="mv /home/heizung/webseiten/*.png /home/heizung/webseiten/1Historie";
qx ($Befehl6);
print "\n";

print "\nschreibe Datei auf Server ...";
$ftp = Net::FTP->new("localhost");   # Hier Deinen Host eingeben
die "Konnte keine Verbindung aufbauen $!" unless $ftp;
$ftp->login("Benutzername", "Passwort");       # Hier Benutzername und Password eingeben
$ftp->cwd("webseiten");               # cwd: Verzeichnis wechseln
$ftp->put("status.html");
$ftp->binary;
$ftp->put("$Tagesdatei");
#$ftp->put("w"."$Tagesdatei");
$ftp->quit;
print "fertig \n";

print "\n";
print "\n Status.htlm ins Archiv kopieren";
my $Befehl9="cp /home/heizung/webseiten/status.html /home/heizung/webseiten/1Historie/status$Jahr"."$Monat"."$Monatstag.html";
qx ($Befehl9);
print "\n";

close ($fd);

my @output = qx(killall perl);
print "@output\n";
